#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count;
    size_t scale_step;
};

Input input_data() {
    Input in;
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    in.numbers.resize(number_count);
    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }

    cerr << "Enter bin count: ";
    cin >> in.bin_count;

    cerr << "Enter scale step (2-9): ";
    cin >> in.scale_step;
    if (in.scale_step < 2 || in.scale_step > 9) {
        cerr << "ERROR: Invalid scale step\n";
    }

    return in;
}

int main() {
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins, in.scale_step);
    return 0;
}
